unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,FileCtrl, StdCtrls,ShlObj,ActiveX, Gauges,pngimage;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  stop:boolean=false;
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var s:string;
begin
s:=edit1.text;
if FileCtrl.SelectDirectory('',edit1.Text,s)
  then edit1.Text:=s;

end;
function SelectDirCB(Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM): Integer stdcall;
begin
  if (uMsg = BFFM_INITIALIZED) and (lpData <> 0) then
    SendMessage(Wnd, BFFM_SETSELECTION, Integer(True), lpdata);
  result := 0;
end;
 
function SelectDirectory(wnd:HWND; const Caption: string; SelRoot: string=''; const Root: WideString='';
                         cFlags:cardinal=BIF_RETURNONLYFSDIRS): string;
var
  WindowList: Pointer;
  BrowseInfo: TBrowseInfo;
  Buffer: PChar;
  OldErrorMode: Cardinal;
  RootItemIDList, ItemIDList: PItemIDList;
  ShellMalloc: IMalloc;
  IDesktopFolder: IShellFolder;
  Eaten, Flags: LongWord;
begin
  Result := '';
  if not DirectoryExists(SelRoot) then SelRoot := '';
  FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
  if (ShGetMalloc(ShellMalloc) = S_OK) and (ShellMalloc <> nil) then
  begin
    Buffer := ShellMalloc.Alloc(MAX_PATH);
    try
      RootItemIDList := nil;
      if Root <> '' then
      begin
        SHGetDesktopFolder(IDesktopFolder);
        IDesktopFolder.ParseDisplayName(Application.Handle, nil,
          POleStr(Root), Eaten, RootItemIDList, Flags);
      end;
      with BrowseInfo do
      begin
        hwndOwner := Application.Handle;
        pidlRoot := RootItemIDList;
        pszDisplayName := Buffer;
        lpszTitle := PChar(Caption);
        ulFlags :=cFlags;
        if SelRoot <> '' then
        begin
          lpfn := SelectDirCB;
          lParam := Integer(PChar(SelRoot));
        end;
      end;
      WindowList := DisableTaskWindows(0);
      OldErrorMode := SetErrorMode(SEM_FAILCRITICALERRORS);
      try
        ItemIDList := ShBrowseForFolder(BrowseInfo);
      finally
        SetErrorMode(OldErrorMode);
        EnableTaskWindows(WindowList);
      end;
      if ItemIDList <> nil then
      begin
        ShGetPathFromIDList(ItemIDList, Buffer);
        ShellMalloc.Free(ItemIDList);
        SetString(Result,Buffer,lstrlen(Buffer));
      end;
    finally
      ShellMalloc.Free(Buffer);
    end;
  end;
end;
procedure TForm1.Button2Click(Sender: TObject);
var
 s:string;
begin
 s:=SelectDirectory(Handle,'  ',Edit2.text,'',
                    BIF_USENEWUI { or BIF_NEWDIALOGSTYLE or BIF_EDITBOX});
                    if s<>'' then
 edit2.Text:=s;
end;


Procedure EnableControl(EditParam:boolean);
var Editmode2,Editmode:boolean;
begin
 if not EditParam then Editmode:=false else Editmode:=true;
 if Editmode then Editmode2:=false else Editmode2:=true;
  form1.Edit1.Enabled:=Editmode;
  form1.Edit2.Enabled:=Editmode;
  form1.Button1.Enabled:=Editmode;
  form1.Button2.Enabled:=Editmode;
  form1.Button3.Enabled:=Editmode;
  form1.Button4.Enabled:=Editmode2;
end;

Procedure ConvertFile(Fln1,fln2:string);
var PngImage:TPNGObject;
    BMP:TBitMap;
begin
try
 PngImage:=TPNGObject.create;
 PngImage.LoadFromFile(Fln1);
 BMP:=TBitMap.Create;
 BMP.Width:=PngImage.Width;
 BMP.Height:=PngImage.Height;
 BMP.Canvas.Draw(0,0,PngImage);
 BMP.SaveToFile(fln2);
 BMP.Free;
 PngImage.Free;
 except
 end;
end;

Procedure myConvertFile(Filename1:string);
var dir2:string;
    Filename2:string;
begin

  if ExtractFileExt(Filename1)<>'' then begin
     Filename2:=copy(Filename1,1,pos(ExtractFileExt(Filename1),Filename1)-1);
  end;

  dir2:=form1.edit2.text;
  if dir2<>'' then if dir2[length(dir2)]<>'\' then dir2:=dir2+'\';
  ConvertFile(Filename1,dir2+ExtractFileName(Filename2)+'.bmp');
end;

procedure FileFinder(Path: string;maska: string;recur: boolean);
var sr : TSearchRec;
begin
if (Path[Length(Path)]='\') then SetLength(Path,Length(Path)-1);
if FindFirst(Path+'\'+maska,faAnyFile,sr)=0
   then
      begin
         if (sr.Attr or faDirectory)=sr.Attr then
            begin
            if (recur=true) then
               begin
                  if (sr.name<>'.') and (sr.name<>'..') then
                  FileFinder(path+'\'+sr.Name,maska,recur);
               end
            end;
         while FindNext(sr) = 0 do
         if (sr.Attr or faDirectory)=sr.Attr then
            begin
            if (recur=true) then
               begin
                  if (sr.name<>'.') and (sr.name<>'..') then
                  FileFinder(path+'\'+sr.Name,maska,recur);
               end
            end
         else

                  myConvertFile(Path+'\'+sr.Name); //   
                  form1.label3.caption:=Path+'\'+sr.Name;
                  application.ProcessMessages;

      end;
   FindClose(sr);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  EnableControl(true);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  FileFinder(edit1.text,'*.png',false);
  Showmessage(' ');
end;

end.
